// Processing 2.2.1

// Main controller / model file for the the Processing Brain Grapher.

// See README.markdown for more info.
// See http://frontiernerds.com/brain-hack for a tutorial on getting started with the Arduino Brain Library and this Processing Brain Grapher.

// Latest source code is on https://github.com/kitschpatrol/Processing-Brain-Grapher
// Created by Eric Mika in Fall 2010, updates Spring 2012 and again in early 2014.

// Modified very mesilly to eliminate arduino and brain library and run direct from necomimi, force trainer or mindflex data (via hacked in bluetooth module)
// by James G Watt September 2015 www.atronix.co.uk
// 

import processing.serial.*;
import controlP5.*;

ControlP5 controlP5;

Serial serial;
Serial serial1;

Channel[] channels = new Channel[11];
Monitor[] monitors = new Monitor[10];
Graph graph;
ConnectionLight connectionLight;

int artCount = 0;
int artronixConnectionValue = 0 ;
int serialOutput = 0;

int packetCount = 0;
int globalMax = 0;
String scaleMode;

//artronix
PImage img;
PImage img2;

int inByte;
int ByteCount  ;
int[] myArray = new int[36];
int[] necomimi = new int[12];


void setup() {
  
  // artronix mods
  // Images must be in the "data" directory to load correctly
  img = loadImage("artronix.jpg");
    img2 = loadImage("artronixframe.png");

  
  
// Set up window
// Edit this to suit your monitor
// to run full screen select Sketch - Present

    size(1024, 768);  // default
    img.resize (1024, 384) ;
    img2.resize (1024, 768) ;

//    size(1366, 768);  // HP Envy Laptop
//    img.resize (1366, 384) ;
//    img2.resize (1366, 768) ;

//    size(1920, 1080);  // ACER screen
//    img.resize (1920, 540) ;
//    img2.resize (1920, 1080) ;

//    size(1024, 768);  // Samsun Small
//    img.resize (1920, 540) ;
//    img2.resize (1920, 1080) ;

//    size(1366, 768);  // Samsun BIG  
//    img.resize (1920, 540) ;
//    img2.resize (1920, 1080) ;


      
/////////////////  
       
  frameRate(60);
  smooth();
  frame.setTitle("Artronix EEG");  

  // Set up serial connection
  println("Find your Arduino in the list below, note its [index]:\n");
  
  for (int i = 0; i < Serial.list().length; i++) {
    println("[" + i + "] " + Serial.list()[i]);
  }
  

  // Put the index found above here:
  // serial in
  // MindFlex and ForceTrainer baud rate 9600
  // Necomimi baud rate 57600
  serial = new Serial(this, Serial.list()[0], 57600);    
//  serial.bufferUntil(10);

// Set up output for arduino hardware 0 = no com out. 1 = com out
serialOutput = 0;

  // Put the index found above here:
  // ARDUINO serial out
  if (serialOutput == 1){
  serial1 = new Serial(this, Serial.list()[0], 9600);    
//  serial1.bufferUntil(10);
  }
  

  // Set up the ControlP5 knobs and dials
  controlP5 = new ControlP5(this);
  controlP5.setColorLabel(color(0));    
  controlP5.setColorBackground(color(0));
  controlP5.disableShortcuts(); 
  controlP5.disableMouseWheel();
  controlP5.setMoveable(false);

  // Create the channel objects
//  channels[0] = new Channel("Signal Quality", color(0), "");
//  channels[1] = new Channel("Attention", color(100), "");
//  channels[2] = new Channel("Meditation", color(50), "");
  channels[0] = new Channel("Signal Quality", color(0), "");
  channels[1] = new Channel(" Attention", color(229, 229, 229), "");
  channels[2] = new Channel(" Meditation", color(178, 178, 178), "");
  channels[3] = new Channel(" Dreamless Sleep", color(255, 18, 18), "Delta");
  channels[4] = new Channel(" Drowsy", color(255, 139, 18), "Theta");
  channels[5] = new Channel(" Relaxed", color(255, 253, 0), "Low Alpha");
  channels[6] = new Channel(" Relaxed", color(0, 255, 3), "High Alpha");
  channels[7] = new Channel(" Alert", color(0, 255, 255), "Low Beta");
  channels[8] = new Channel(" Alert", color(42, 116, 255), "High Beta");
  channels[9] = new Channel(" Multi-sensory", color(66, 66, 255), "Low Gamma");
  channels[10] = new Channel(" Processing", color(255, 41, 153), "High Gamma");

  // Manual override for a couple of limits.
  channels[0].minValue = 0;
  channels[0].maxValue = 200;
  channels[1].minValue = 0;
  channels[1].maxValue = 100;
  channels[2].minValue = 0;
  channels[2].maxValue = 100;
  channels[0].allowGlobal = false;
  channels[1].allowGlobal = false;
  channels[2].allowGlobal = false;

  // Set up the monitors, skip the signal quality
  for (int i = 0; i < monitors.length; i++) {
    monitors[i] = new Monitor(channels[i + 1], i * (width / 10), height / 2, width / 10, height / 2);
  }

  monitors[monitors.length - 1].w += width % monitors.length;

  // Set up the graph
  graph = new Graph(0, 0, width, height / 2);

  // Set yup the connection light
  connectionLight = new ConnectionLight(width - 140, 10, 20);
}

void draw() {
  

  
  // Keep track of global maxima
  if (scaleMode == "Global" && (channels.length > 3)) {
    for (int i = 3; i < channels.length; i++) {
      if (channels[i].maxValue > globalMax) globalMax = channels[i].maxValue;
    }
  }

  // Clear the background
  background(255);

  // Update and draw the main graph
  graph.update();
  graph.draw();

  // Update and draw the connection light
  connectionLight.update();
  connectionLight.draw();

  // Update and draw the monitors
  for (int i = 0; i < monitors.length; i++) {
    monitors[i].update();
    monitors[i].draw();
    
 
while (serial.available() > 32) {
 inByte = serial.read();
if(inByte == 170){
 inByte = serial.read();
if(inByte == 170){
 inByte = serial.read();
if(inByte == 32){
necomimi();
}
}
}

  }
  }
    
  
}

void necomimi(){


  
for(ByteCount = 3 ; ByteCount < 35 ;     ByteCount ++  )  
    {
    int inByte = serial.read();
    myArray[ByteCount] = inByte; 
    }
 

//necomimi[0] = myArray[4] ; // signal strength 0-255. 0=good 200 = no contact.
//necomimi[1] = myArray[32] ; // Attention 0-100
//necomimi[2] = myArray[34] ; // Meditation 0-100
//necomimi[3] = (myArray[9]+(256*myArray[8])+(65536*myArray[7])); // delta (0.5 - 2.75Hz)
//necomimi[4] = (myArray[12]+(256*myArray[11])+(65536*myArray[10])); // theta (3.5 - 6.75Hz)
//necomimi[5] = (myArray[15]+(256*myArray[14])+(65536*myArray[13])); // low-alpha (7.5 - 9.25Hz)
//necomimi[6] = (myArray[18]+(256*myArray[17])+(65536*myArray[16])); // high-alpha (10 - 11.75Hz)
//necomimi[7] = (myArray[21]+(256*myArray[20])+(65536*myArray[19])); // low-beta (13 - 16.75Hz)
//necomimi[8] = (myArray[24]+(256*myArray[23])+(65536*myArray[22])); // high-beta (18 - 29.75Hz)
//necomimi[9] = (myArray[27]+(256*myArray[26])+(65536*myArray[25])); // low-gamma (31 - 39.75Hz)
//necomimi[10] = (myArray[30]+(256*myArray[29])+(65536*myArray[28])); // mid-gamma (41 - 49.75Hz)
//necomimi[11] ++ ; // packet count
  
     packetCount++;
     channels[0].addDataPoint(myArray[4]); // signal strength 0-255. 0=good 200 = no contact.
     channels[1].addDataPoint(myArray[32]) ; // Attention 0-100
     channels[2].addDataPoint(myArray[34]) ; // Meditation 0-100
     channels[3].addDataPoint(myArray[9]+(256*myArray[8])+(65536*myArray[7])); // delta (0.5 - 2.75Hz)
     channels[4].addDataPoint(myArray[12]+(256*myArray[11])+(65536*myArray[10])); // theta (3.5 - 6.75Hz)
     channels[5].addDataPoint(myArray[15]+(256*myArray[14])+(65536*myArray[13])); // low-alpha (7.5 - 9.25Hz)
     channels[6].addDataPoint(myArray[18]+(256*myArray[17])+(65536*myArray[16])); // high-alpha (10 - 11.75Hz)
     channels[7].addDataPoint(myArray[21]+(256*myArray[20])+(65536*myArray[19])); // low-beta (13 - 16.75Hz)
     channels[8].addDataPoint(myArray[24]+(256*myArray[23])+(65536*myArray[22])); // high-beta (18 - 29.75Hz)
     channels[9].addDataPoint(myArray[27]+(256*myArray[26])+(65536*myArray[25])); // low-gamma (31 - 39.75Hz)
     channels[10].addDataPoint(myArray[30]+(256*myArray[29])+(65536*myArray[28])); // mid-gamma (41 - 49.75Hz)
     

if (serialOutput == 1){
  serial1.write (255) ;
  serial1.write (myArray[4]) ;
    serial1.write (myArray[32]) ;
      serial1.write (myArray[34]) ;
}else{    
  println ();
  println (myArray[32]) ;
      println (myArray[34]) ;}

    monitors[2].spitout();
    monitors[3].spitout();
    monitors[4].spitout();
    monitors[5].spitout();
    monitors[6].spitout();
    monitors[7].spitout();
    monitors[8].spitout();
    monitors[9].spitout();

    }


// Utilities

// Extend Processing's built-in map() function to support the Long datatype
long mapLong(long x, long in_min, long in_max, long out_min, long out_max) { 
  return (x - in_min) * (out_max - out_min) / (in_max - in_min) + out_min;
}

// Extend Processing's built-in constrain() function to support the Long datatype
long constrainLong(long value, long min_value, long max_value) {
  if (value > max_value) return max_value;
  if (value < min_value) return min_value;
  return value;
}
